
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import decimal
import java.lang
import java.math
import jpype
import org.kie.api.runtime.rule
import org.optaplanner.core.api.score
import org.optaplanner.core.api.score.holder
import typing



class BendableBigDecimalScore(org.optaplanner.core.api.score.IBendableScore['BendableBigDecimalScore']):
    def abs(self) -> 'BendableBigDecimalScore': ...
    def add(self, bendableBigDecimalScore: 'BendableBigDecimalScore') -> 'BendableBigDecimalScore': ...
    def compareTo(self, bendableBigDecimalScore: 'BendableBigDecimalScore') -> int: ...
    def divide(self, double: float) -> 'BendableBigDecimalScore': ...
    def equals(self, object: typing.Any) -> bool: ...
    def getHardOrSoftScore(self, int: int) -> java.math.BigDecimal: ...
    def getHardScore(self, int: int) -> java.math.BigDecimal: ...
    def getHardScores(self) -> typing.MutableSequence[java.math.BigDecimal]: ...
    def getSoftScore(self, int: int) -> java.math.BigDecimal: ...
    def getSoftScores(self) -> typing.MutableSequence[java.math.BigDecimal]: ...
    def hardLevelsSize(self) -> int: ...
    def hardOrSoftScore(self, int: int) -> java.math.BigDecimal: ...
    def hardScore(self, int: int) -> java.math.BigDecimal: ...
    def hardScores(self) -> typing.MutableSequence[java.math.BigDecimal]: ...
    def hashCode(self) -> int: ...
    def initScore(self) -> int: ...
    def isFeasible(self) -> bool: ...
    def multiply(self, double: float) -> 'BendableBigDecimalScore': ...
    def negate(self) -> 'BendableBigDecimalScore': ...
    @staticmethod
    def of(bigDecimalArray: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray], bigDecimalArray2: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray]) -> 'BendableBigDecimalScore': ...
    @staticmethod
    def ofHard(int: int, int2: int, int3: int, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'BendableBigDecimalScore': ...
    @staticmethod
    def ofSoft(int: int, int2: int, int3: int, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'BendableBigDecimalScore': ...
    @staticmethod
    def ofUninitialized(int: int, bigDecimalArray: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray], bigDecimalArray2: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray]) -> 'BendableBigDecimalScore': ...
    @staticmethod
    def parseScore(string: str) -> 'BendableBigDecimalScore': ...
    def power(self, double: float) -> 'BendableBigDecimalScore': ...
    def softLevelsSize(self) -> int: ...
    def softScore(self, int: int) -> java.math.BigDecimal: ...
    def softScores(self) -> typing.MutableSequence[java.math.BigDecimal]: ...
    def subtract(self, bendableBigDecimalScore: 'BendableBigDecimalScore') -> 'BendableBigDecimalScore': ...
    def toLevelNumbers(self) -> typing.MutableSequence[java.lang.Number]: ...
    def toShortString(self) -> str: ...
    def toString(self) -> str: ...
    def validateCompatible(self, bendableBigDecimalScore: 'BendableBigDecimalScore') -> None: ...
    def withInitScore(self, int: int) -> 'BendableBigDecimalScore': ...
    @typing.overload
    def zero(self) -> 'BendableBigDecimalScore': ...
    @typing.overload
    @staticmethod
    def zero(int: int, int2: int) -> 'BendableBigDecimalScore': ...

class BendableBigDecimalScoreHolder(org.optaplanner.core.api.score.holder.ScoreHolder[BendableBigDecimalScore]):
    def addHardConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    def addMultiConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimalArray: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray], bigDecimalArray2: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray]) -> None: ...
    def addSoftConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    def getHardLevelsSize(self) -> int: ...
    def getSoftLevelsSize(self) -> int: ...
    def impactScore(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimalArray: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray], bigDecimalArray2: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimalArray: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray], bigDecimalArray2: typing.Union[typing.List[java.math.BigDecimal], jpype.JArray]) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.api.score.buildin.bendablebigdecimal")``.

    BendableBigDecimalScore: typing.Type[BendableBigDecimalScore]
    BendableBigDecimalScoreHolder: typing.Type[BendableBigDecimalScoreHolder]
