
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import jpype
import org.kie.api.runtime.rule
import org.optaplanner.core.api.score
import org.optaplanner.core.api.score.holder
import typing



class BendableLongScore(org.optaplanner.core.api.score.IBendableScore['BendableLongScore']):
    def abs(self) -> 'BendableLongScore': ...
    def add(self, bendableLongScore: 'BendableLongScore') -> 'BendableLongScore': ...
    def compareTo(self, bendableLongScore: 'BendableLongScore') -> int: ...
    def divide(self, double: float) -> 'BendableLongScore': ...
    def equals(self, object: typing.Any) -> bool: ...
    def getHardOrSoftScore(self, int: int) -> int: ...
    def getHardScore(self, int: int) -> int: ...
    def getHardScores(self) -> typing.MutableSequence[int]: ...
    def getSoftScore(self, int: int) -> int: ...
    def getSoftScores(self) -> typing.MutableSequence[int]: ...
    def hardLevelsSize(self) -> int: ...
    def hardOrSoftScore(self, int: int) -> int: ...
    def hardScore(self, int: int) -> int: ...
    def hardScores(self) -> typing.MutableSequence[int]: ...
    def hashCode(self) -> int: ...
    def initScore(self) -> int: ...
    def isFeasible(self) -> bool: ...
    def multiply(self, double: float) -> 'BendableLongScore': ...
    def negate(self) -> 'BendableLongScore': ...
    @staticmethod
    def of(longArray: typing.Union[typing.List[int], jpype.JArray], longArray2: typing.Union[typing.List[int], jpype.JArray]) -> 'BendableLongScore': ...
    @staticmethod
    def ofHard(int: int, int2: int, int3: int, long: int) -> 'BendableLongScore': ...
    @staticmethod
    def ofSoft(int: int, int2: int, int3: int, long: int) -> 'BendableLongScore': ...
    @staticmethod
    def ofUninitialized(int: int, longArray: typing.Union[typing.List[int], jpype.JArray], longArray2: typing.Union[typing.List[int], jpype.JArray]) -> 'BendableLongScore': ...
    @staticmethod
    def parseScore(string: str) -> 'BendableLongScore': ...
    def power(self, double: float) -> 'BendableLongScore': ...
    def softLevelsSize(self) -> int: ...
    def softScore(self, int: int) -> int: ...
    def softScores(self) -> typing.MutableSequence[int]: ...
    def subtract(self, bendableLongScore: 'BendableLongScore') -> 'BendableLongScore': ...
    def toLevelNumbers(self) -> typing.MutableSequence[java.lang.Number]: ...
    def toShortString(self) -> str: ...
    def toString(self) -> str: ...
    def validateCompatible(self, bendableLongScore: 'BendableLongScore') -> None: ...
    def withInitScore(self, int: int) -> 'BendableLongScore': ...
    @typing.overload
    def zero(self) -> 'BendableLongScore': ...
    @typing.overload
    @staticmethod
    def zero(int: int, int2: int) -> 'BendableLongScore': ...

class BendableLongScoreHolder(org.optaplanner.core.api.score.holder.ScoreHolder[BendableLongScore]):
    def addHardConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int, long: int) -> None: ...
    def addMultiConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, longArray: typing.Union[typing.List[int], jpype.JArray], longArray2: typing.Union[typing.List[int], jpype.JArray]) -> None: ...
    def addSoftConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int, long: int) -> None: ...
    def getHardLevelsSize(self) -> int: ...
    def getSoftLevelsSize(self) -> int: ...
    def impactScore(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, longArray: typing.Union[typing.List[int], jpype.JArray], longArray2: typing.Union[typing.List[int], jpype.JArray]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, longArray: typing.Union[typing.List[int], jpype.JArray], longArray2: typing.Union[typing.List[int], jpype.JArray]) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.api.score.buildin.bendablelong")``.

    BendableLongScore: typing.Type[BendableLongScore]
    BendableLongScoreHolder: typing.Type[BendableLongScoreHolder]
