
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import decimal
import java.lang
import java.math
import org.kie.api.runtime.rule
import org.optaplanner.core.api.score
import org.optaplanner.core.api.score.holder
import typing



class HardMediumSoftBigDecimalScore(org.optaplanner.core.api.score.Score['HardMediumSoftBigDecimalScore']):
    ZERO: typing.ClassVar['HardMediumSoftBigDecimalScore'] = ...
    ONE_HARD: typing.ClassVar['HardMediumSoftBigDecimalScore'] = ...
    ONE_MEDIUM: typing.ClassVar['HardMediumSoftBigDecimalScore'] = ...
    ONE_SOFT: typing.ClassVar['HardMediumSoftBigDecimalScore'] = ...
    def abs(self) -> 'HardMediumSoftBigDecimalScore': ...
    def add(self, hardMediumSoftBigDecimalScore: 'HardMediumSoftBigDecimalScore') -> 'HardMediumSoftBigDecimalScore': ...
    def compareTo(self, hardMediumSoftBigDecimalScore: 'HardMediumSoftBigDecimalScore') -> int: ...
    def divide(self, double: float) -> 'HardMediumSoftBigDecimalScore': ...
    def equals(self, object: typing.Any) -> bool: ...
    def getHardScore(self) -> java.math.BigDecimal: ...
    def getMediumScore(self) -> java.math.BigDecimal: ...
    def getSoftScore(self) -> java.math.BigDecimal: ...
    def hardScore(self) -> java.math.BigDecimal: ...
    def hashCode(self) -> int: ...
    def initScore(self) -> int: ...
    def isFeasible(self) -> bool: ...
    def mediumScore(self) -> java.math.BigDecimal: ...
    def multiply(self, double: float) -> 'HardMediumSoftBigDecimalScore': ...
    @staticmethod
    def of(bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal2: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal3: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'HardMediumSoftBigDecimalScore': ...
    @staticmethod
    def ofHard(bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'HardMediumSoftBigDecimalScore': ...
    @staticmethod
    def ofMedium(bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'HardMediumSoftBigDecimalScore': ...
    @staticmethod
    def ofSoft(bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'HardMediumSoftBigDecimalScore': ...
    @staticmethod
    def ofUninitialized(int: int, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal2: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal3: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'HardMediumSoftBigDecimalScore': ...
    @staticmethod
    def parseScore(string: str) -> 'HardMediumSoftBigDecimalScore': ...
    def power(self, double: float) -> 'HardMediumSoftBigDecimalScore': ...
    def softScore(self) -> java.math.BigDecimal: ...
    def subtract(self, hardMediumSoftBigDecimalScore: 'HardMediumSoftBigDecimalScore') -> 'HardMediumSoftBigDecimalScore': ...
    def toLevelNumbers(self) -> typing.MutableSequence[java.lang.Number]: ...
    def toShortString(self) -> str: ...
    def toString(self) -> str: ...
    def withInitScore(self, int: int) -> 'HardMediumSoftBigDecimalScore': ...
    def zero(self) -> 'HardMediumSoftBigDecimalScore': ...

class HardMediumSoftBigDecimalScoreHolder(org.optaplanner.core.api.score.holder.ScoreHolder[HardMediumSoftBigDecimalScore]):
    def addHardConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    def addMediumConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    def addMultiConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal2: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal3: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    def addSoftConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    def impactScore(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal2: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal3: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal2: typing.Union[java.math.BigDecimal, decimal.Decimal], bigDecimal3: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.api.score.buildin.hardmediumsoftbigdecimal")``.

    HardMediumSoftBigDecimalScore: typing.Type[HardMediumSoftBigDecimalScore]
    HardMediumSoftBigDecimalScoreHolder: typing.Type[HardMediumSoftBigDecimalScoreHolder]
