
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import org.kie.api.runtime.rule
import org.optaplanner.core.api.score
import org.optaplanner.core.api.score.holder
import typing



class HardMediumSoftLongScore(org.optaplanner.core.api.score.Score['HardMediumSoftLongScore']):
    ZERO: typing.ClassVar['HardMediumSoftLongScore'] = ...
    ONE_HARD: typing.ClassVar['HardMediumSoftLongScore'] = ...
    ONE_MEDIUM: typing.ClassVar['HardMediumSoftLongScore'] = ...
    ONE_SOFT: typing.ClassVar['HardMediumSoftLongScore'] = ...
    def abs(self) -> 'HardMediumSoftLongScore': ...
    def add(self, hardMediumSoftLongScore: 'HardMediumSoftLongScore') -> 'HardMediumSoftLongScore': ...
    def compareTo(self, hardMediumSoftLongScore: 'HardMediumSoftLongScore') -> int: ...
    def divide(self, double: float) -> 'HardMediumSoftLongScore': ...
    def equals(self, object: typing.Any) -> bool: ...
    def getHardScore(self) -> int: ...
    def getMediumScore(self) -> int: ...
    def getSoftScore(self) -> int: ...
    def hardScore(self) -> int: ...
    def hashCode(self) -> int: ...
    def initScore(self) -> int: ...
    def isFeasible(self) -> bool: ...
    def mediumScore(self) -> int: ...
    def multiply(self, double: float) -> 'HardMediumSoftLongScore': ...
    @staticmethod
    def of(long: int, long2: int, long3: int) -> 'HardMediumSoftLongScore': ...
    @staticmethod
    def ofHard(long: int) -> 'HardMediumSoftLongScore': ...
    @staticmethod
    def ofMedium(long: int) -> 'HardMediumSoftLongScore': ...
    @staticmethod
    def ofSoft(long: int) -> 'HardMediumSoftLongScore': ...
    @staticmethod
    def ofUninitialized(int: int, long: int, long2: int, long3: int) -> 'HardMediumSoftLongScore': ...
    @staticmethod
    def parseScore(string: str) -> 'HardMediumSoftLongScore': ...
    def power(self, double: float) -> 'HardMediumSoftLongScore': ...
    def softScore(self) -> int: ...
    def subtract(self, hardMediumSoftLongScore: 'HardMediumSoftLongScore') -> 'HardMediumSoftLongScore': ...
    def toLevelNumbers(self) -> typing.MutableSequence[java.lang.Number]: ...
    def toShortString(self) -> str: ...
    def toString(self) -> str: ...
    def withInitScore(self, int: int) -> 'HardMediumSoftLongScore': ...
    def zero(self) -> 'HardMediumSoftLongScore': ...

class HardMediumSoftLongScoreHolder(org.optaplanner.core.api.score.holder.ScoreHolder[HardMediumSoftLongScore]):
    def addHardConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    def addMediumConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    def addMultiConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int, long2: int, long3: int) -> None: ...
    def addSoftConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    def impactScore(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int, long2: int, long3: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, long: int, long2: int, long3: int) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.api.score.buildin.hardmediumsoftlong")``.

    HardMediumSoftLongScore: typing.Type[HardMediumSoftLongScore]
    HardMediumSoftLongScoreHolder: typing.Type[HardMediumSoftLongScoreHolder]
