
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import org.kie.api.runtime.rule
import org.optaplanner.core.api.score
import org.optaplanner.core.api.score.holder
import typing



class HardSoftScore(org.optaplanner.core.api.score.Score['HardSoftScore']):
    ZERO: typing.ClassVar['HardSoftScore'] = ...
    ONE_HARD: typing.ClassVar['HardSoftScore'] = ...
    ONE_SOFT: typing.ClassVar['HardSoftScore'] = ...
    def abs(self) -> 'HardSoftScore': ...
    def add(self, hardSoftScore: 'HardSoftScore') -> 'HardSoftScore': ...
    def compareTo(self, hardSoftScore: 'HardSoftScore') -> int: ...
    def divide(self, double: float) -> 'HardSoftScore': ...
    def equals(self, object: typing.Any) -> bool: ...
    def getHardScore(self) -> int: ...
    def getSoftScore(self) -> int: ...
    def hardScore(self) -> int: ...
    def hashCode(self) -> int: ...
    def initScore(self) -> int: ...
    def isFeasible(self) -> bool: ...
    def multiply(self, double: float) -> 'HardSoftScore': ...
    @staticmethod
    def of(int: int, int2: int) -> 'HardSoftScore': ...
    @staticmethod
    def ofHard(int: int) -> 'HardSoftScore': ...
    @staticmethod
    def ofSoft(int: int) -> 'HardSoftScore': ...
    @staticmethod
    def ofUninitialized(int: int, int2: int, int3: int) -> 'HardSoftScore': ...
    @staticmethod
    def parseScore(string: str) -> 'HardSoftScore': ...
    def power(self, double: float) -> 'HardSoftScore': ...
    def softScore(self) -> int: ...
    def subtract(self, hardSoftScore: 'HardSoftScore') -> 'HardSoftScore': ...
    def toLevelNumbers(self) -> typing.MutableSequence[java.lang.Number]: ...
    def toShortString(self) -> str: ...
    def toString(self) -> str: ...
    def withInitScore(self, int: int) -> 'HardSoftScore': ...
    def zero(self) -> 'HardSoftScore': ...

class HardSoftScoreHolder(org.optaplanner.core.api.score.holder.ScoreHolder[HardSoftScore]):
    def addHardConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int) -> None: ...
    def addMultiConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int, int2: int) -> None: ...
    def addSoftConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int) -> None: ...
    def impactScore(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int, int2: int) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, int: int, int2: int) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.api.score.buildin.hardsoft")``.

    HardSoftScore: typing.Type[HardSoftScore]
    HardSoftScoreHolder: typing.Type[HardSoftScoreHolder]
