
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import decimal
import java.lang
import java.math
import org.kie.api.runtime.rule
import org.optaplanner.core.api.score
import org.optaplanner.core.api.score.holder
import typing



class SimpleBigDecimalScore(org.optaplanner.core.api.score.Score['SimpleBigDecimalScore']):
    ZERO: typing.ClassVar['SimpleBigDecimalScore'] = ...
    ONE: typing.ClassVar['SimpleBigDecimalScore'] = ...
    def abs(self) -> 'SimpleBigDecimalScore': ...
    def add(self, simpleBigDecimalScore: 'SimpleBigDecimalScore') -> 'SimpleBigDecimalScore': ...
    def compareTo(self, simpleBigDecimalScore: 'SimpleBigDecimalScore') -> int: ...
    def divide(self, double: float) -> 'SimpleBigDecimalScore': ...
    def equals(self, object: typing.Any) -> bool: ...
    def getScore(self) -> java.math.BigDecimal: ...
    def hashCode(self) -> int: ...
    def initScore(self) -> int: ...
    def isFeasible(self) -> bool: ...
    def multiply(self, double: float) -> 'SimpleBigDecimalScore': ...
    @staticmethod
    def of(bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'SimpleBigDecimalScore': ...
    @staticmethod
    def ofUninitialized(int: int, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> 'SimpleBigDecimalScore': ...
    @staticmethod
    def parseScore(string: str) -> 'SimpleBigDecimalScore': ...
    def power(self, double: float) -> 'SimpleBigDecimalScore': ...
    def score(self) -> java.math.BigDecimal: ...
    def subtract(self, simpleBigDecimalScore: 'SimpleBigDecimalScore') -> 'SimpleBigDecimalScore': ...
    def toLevelNumbers(self) -> typing.MutableSequence[java.lang.Number]: ...
    def toShortString(self) -> str: ...
    def toString(self) -> str: ...
    def withInitScore(self, int: int) -> 'SimpleBigDecimalScore': ...
    def zero(self) -> 'SimpleBigDecimalScore': ...

class SimpleBigDecimalScoreHolder(org.optaplanner.core.api.score.holder.ScoreHolder[SimpleBigDecimalScore]):
    def addConstraintMatch(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    def impactScore(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def penalize(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext, bigDecimal: typing.Union[java.math.BigDecimal, decimal.Decimal]) -> None: ...
    @typing.overload
    def reward(self, ruleContext: org.kie.api.runtime.rule.RuleContext) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.api.score.buildin.simplebigdecimal")``.

    SimpleBigDecimalScore: typing.Type[SimpleBigDecimalScore]
    SimpleBigDecimalScoreHolder: typing.Type[SimpleBigDecimalScoreHolder]
