
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import java.util
import java.util.function
import org.optaplanner.core.config.heuristic.selector
import org.optaplanner.core.config.heuristic.selector.common
import org.optaplanner.core.config.heuristic.selector.common.decorator
import org.optaplanner.core.config.heuristic.selector.common.nearby
import org.optaplanner.core.config.heuristic.selector.entity.pillar
import org.optaplanner.core.impl.domain.entity.descriptor
import org.optaplanner.core.impl.heuristic.selector.common.decorator
import typing



class EntitySelectorConfig(org.optaplanner.core.config.heuristic.selector.SelectorConfig['EntitySelectorConfig']):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, class_: typing.Type[typing.Any]): ...
    @typing.overload
    def __init__(self, entitySelectorConfig: 'EntitySelectorConfig'): ...
    def copyConfig(self) -> 'EntitySelectorConfig': ...
    _determineSorter__Solution_ = typing.TypeVar('_determineSorter__Solution_')  # <Solution_>
    _determineSorter__T = typing.TypeVar('_determineSorter__T')  # <T>
    @staticmethod
    def determineSorter(entitySorterManner: 'EntitySorterManner', entityDescriptor: org.optaplanner.core.impl.domain.entity.descriptor.EntityDescriptor[_determineSorter__Solution_]) -> org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter[_determineSorter__Solution_, _determineSorter__T]: ...
    def getCacheType(self) -> org.optaplanner.core.config.heuristic.selector.common.SelectionCacheType: ...
    def getEntityClass(self) -> typing.Type[typing.Any]: ...
    def getFilterClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionFilter]: ...
    def getId(self) -> str: ...
    def getMimicSelectorRef(self) -> str: ...
    def getNearbySelectionConfig(self) -> org.optaplanner.core.config.heuristic.selector.common.nearby.NearbySelectionConfig: ...
    def getProbabilityWeightFactoryClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionProbabilityWeightFactory]: ...
    def getSelectedCountLimit(self) -> int: ...
    def getSelectionOrder(self) -> org.optaplanner.core.config.heuristic.selector.common.SelectionOrder: ...
    def getSorterClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter]: ...
    def getSorterComparatorClass(self) -> typing.Type[java.util.Comparator]: ...
    def getSorterManner(self) -> 'EntitySorterManner': ...
    def getSorterOrder(self) -> org.optaplanner.core.config.heuristic.selector.common.decorator.SelectionSorterOrder: ...
    def getSorterWeightFactoryClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorterWeightFactory]: ...
    _hasSorter__Solution_ = typing.TypeVar('_hasSorter__Solution_')  # <Solution_>
    @staticmethod
    def hasSorter(entitySorterManner: 'EntitySorterManner', entityDescriptor: org.optaplanner.core.impl.domain.entity.descriptor.EntityDescriptor[_hasSorter__Solution_]) -> bool: ...
    def inherit(self, entitySelectorConfig: 'EntitySelectorConfig') -> 'EntitySelectorConfig': ...
    @staticmethod
    def newMimicSelectorConfig(string: str) -> 'EntitySelectorConfig': ...
    def setCacheType(self, selectionCacheType: org.optaplanner.core.config.heuristic.selector.common.SelectionCacheType) -> None: ...
    def setEntityClass(self, class_: typing.Type[typing.Any]) -> None: ...
    def setFilterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionFilter]) -> None: ...
    def setId(self, string: str) -> None: ...
    def setMimicSelectorRef(self, string: str) -> None: ...
    def setNearbySelectionConfig(self, nearbySelectionConfig: org.optaplanner.core.config.heuristic.selector.common.nearby.NearbySelectionConfig) -> None: ...
    def setProbabilityWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionProbabilityWeightFactory]) -> None: ...
    def setSelectedCountLimit(self, long: int) -> None: ...
    def setSelectionOrder(self, selectionOrder: org.optaplanner.core.config.heuristic.selector.common.SelectionOrder) -> None: ...
    def setSorterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter]) -> None: ...
    def setSorterComparatorClass(self, class_: typing.Type[java.util.Comparator]) -> None: ...
    def setSorterManner(self, entitySorterManner: 'EntitySorterManner') -> None: ...
    def setSorterOrder(self, selectionSorterOrder: org.optaplanner.core.config.heuristic.selector.common.decorator.SelectionSorterOrder) -> None: ...
    def setSorterWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorterWeightFactory]) -> None: ...
    def toString(self) -> str: ...
    def visitReferencedClasses(self, consumer: typing.Union[java.util.function.Consumer[typing.Type[typing.Any]], typing.Callable[[typing.Type[typing.Any]], None]]) -> None: ...
    def withCacheType(self, selectionCacheType: org.optaplanner.core.config.heuristic.selector.common.SelectionCacheType) -> 'EntitySelectorConfig': ...
    def withEntityClass(self, class_: typing.Type[typing.Any]) -> 'EntitySelectorConfig': ...
    def withFilterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionFilter]) -> 'EntitySelectorConfig': ...
    def withId(self, string: str) -> 'EntitySelectorConfig': ...
    def withMimicSelectorRef(self, string: str) -> 'EntitySelectorConfig': ...
    def withNearbySelectionConfig(self, nearbySelectionConfig: org.optaplanner.core.config.heuristic.selector.common.nearby.NearbySelectionConfig) -> 'EntitySelectorConfig': ...
    def withProbabilityWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionProbabilityWeightFactory]) -> 'EntitySelectorConfig': ...
    def withSelectedCountLimit(self, long: int) -> 'EntitySelectorConfig': ...
    def withSelectionOrder(self, selectionOrder: org.optaplanner.core.config.heuristic.selector.common.SelectionOrder) -> 'EntitySelectorConfig': ...
    def withSorterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter]) -> 'EntitySelectorConfig': ...
    def withSorterComparatorClass(self, class_: typing.Type[java.util.Comparator]) -> 'EntitySelectorConfig': ...
    def withSorterManner(self, entitySorterManner: 'EntitySorterManner') -> 'EntitySelectorConfig': ...
    def withSorterOrder(self, selectionSorterOrder: org.optaplanner.core.config.heuristic.selector.common.decorator.SelectionSorterOrder) -> 'EntitySelectorConfig': ...
    def withSorterWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorterWeightFactory]) -> 'EntitySelectorConfig': ...

class EntitySorterManner(java.lang.Enum['EntitySorterManner']):
    NONE: typing.ClassVar['EntitySorterManner'] = ...
    DECREASING_DIFFICULTY: typing.ClassVar['EntitySorterManner'] = ...
    DECREASING_DIFFICULTY_IF_AVAILABLE: typing.ClassVar['EntitySorterManner'] = ...
    _valueOf_0__T = typing.TypeVar('_valueOf_0__T', bound=java.lang.Enum)  # <T>
    @typing.overload
    @staticmethod
    def valueOf(class_: typing.Type[_valueOf_0__T], string: str) -> _valueOf_0__T: ...
    @typing.overload
    @staticmethod
    def valueOf(string: str) -> 'EntitySorterManner': ...
    @staticmethod
    def values() -> typing.MutableSequence['EntitySorterManner']: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.config.heuristic.selector.entity")``.

    EntitySelectorConfig: typing.Type[EntitySelectorConfig]
    EntitySorterManner: typing.Type[EntitySorterManner]
    pillar: org.optaplanner.core.config.heuristic.selector.entity.pillar.__module_protocol__
