
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import java.util
import java.util.function
import org.optaplanner.core.config.heuristic.selector
import org.optaplanner.core.config.heuristic.selector.common
import org.optaplanner.core.config.heuristic.selector.common.decorator
import org.optaplanner.core.config.heuristic.selector.common.nearby
import org.optaplanner.core.config.heuristic.selector.value.chained
import org.optaplanner.core.impl.domain.variable.descriptor
import org.optaplanner.core.impl.heuristic.selector.common.decorator
import typing



class ValueSelectorConfig(org.optaplanner.core.config.heuristic.selector.SelectorConfig['ValueSelectorConfig']):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, string: str): ...
    @typing.overload
    def __init__(self, valueSelectorConfig: 'ValueSelectorConfig'): ...
    def copyConfig(self) -> 'ValueSelectorConfig': ...
    _determineSorter__Solution_ = typing.TypeVar('_determineSorter__Solution_')  # <Solution_>
    @staticmethod
    def determineSorter(valueSorterManner: 'ValueSorterManner', genuineVariableDescriptor: org.optaplanner.core.impl.domain.variable.descriptor.GenuineVariableDescriptor[_determineSorter__Solution_]) -> org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter[_determineSorter__Solution_, typing.Any]: ...
    def getCacheType(self) -> org.optaplanner.core.config.heuristic.selector.common.SelectionCacheType: ...
    def getDowncastEntityClass(self) -> typing.Type[typing.Any]: ...
    def getFilterClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionFilter]: ...
    def getId(self) -> str: ...
    def getMimicSelectorRef(self) -> str: ...
    def getNearbySelectionConfig(self) -> org.optaplanner.core.config.heuristic.selector.common.nearby.NearbySelectionConfig: ...
    def getProbabilityWeightFactoryClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionProbabilityWeightFactory]: ...
    def getSelectedCountLimit(self) -> int: ...
    def getSelectionOrder(self) -> org.optaplanner.core.config.heuristic.selector.common.SelectionOrder: ...
    def getSorterClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter]: ...
    def getSorterComparatorClass(self) -> typing.Type[java.util.Comparator]: ...
    def getSorterManner(self) -> 'ValueSorterManner': ...
    def getSorterOrder(self) -> org.optaplanner.core.config.heuristic.selector.common.decorator.SelectionSorterOrder: ...
    def getSorterWeightFactoryClass(self) -> typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorterWeightFactory]: ...
    def getVariableName(self) -> str: ...
    _hasSorter__Solution_ = typing.TypeVar('_hasSorter__Solution_')  # <Solution_>
    @staticmethod
    def hasSorter(valueSorterManner: 'ValueSorterManner', genuineVariableDescriptor: org.optaplanner.core.impl.domain.variable.descriptor.GenuineVariableDescriptor[_hasSorter__Solution_]) -> bool: ...
    def inherit(self, valueSelectorConfig: 'ValueSelectorConfig') -> 'ValueSelectorConfig': ...
    def setCacheType(self, selectionCacheType: org.optaplanner.core.config.heuristic.selector.common.SelectionCacheType) -> None: ...
    def setDowncastEntityClass(self, class_: typing.Type[typing.Any]) -> None: ...
    def setFilterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionFilter]) -> None: ...
    def setId(self, string: str) -> None: ...
    def setMimicSelectorRef(self, string: str) -> None: ...
    def setNearbySelectionConfig(self, nearbySelectionConfig: org.optaplanner.core.config.heuristic.selector.common.nearby.NearbySelectionConfig) -> None: ...
    def setProbabilityWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionProbabilityWeightFactory]) -> None: ...
    def setSelectedCountLimit(self, long: int) -> None: ...
    def setSelectionOrder(self, selectionOrder: org.optaplanner.core.config.heuristic.selector.common.SelectionOrder) -> None: ...
    def setSorterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter]) -> None: ...
    def setSorterComparatorClass(self, class_: typing.Type[java.util.Comparator]) -> None: ...
    def setSorterManner(self, valueSorterManner: 'ValueSorterManner') -> None: ...
    def setSorterOrder(self, selectionSorterOrder: org.optaplanner.core.config.heuristic.selector.common.decorator.SelectionSorterOrder) -> None: ...
    def setSorterWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorterWeightFactory]) -> None: ...
    def setVariableName(self, string: str) -> None: ...
    def toString(self) -> str: ...
    def visitReferencedClasses(self, consumer: typing.Union[java.util.function.Consumer[typing.Type[typing.Any]], typing.Callable[[typing.Type[typing.Any]], None]]) -> None: ...
    def withCacheType(self, selectionCacheType: org.optaplanner.core.config.heuristic.selector.common.SelectionCacheType) -> 'ValueSelectorConfig': ...
    def withDowncastEntityClass(self, class_: typing.Type[typing.Any]) -> 'ValueSelectorConfig': ...
    def withFilterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionFilter]) -> 'ValueSelectorConfig': ...
    def withId(self, string: str) -> 'ValueSelectorConfig': ...
    def withMimicSelectorRef(self, string: str) -> 'ValueSelectorConfig': ...
    def withNearbySelectionConfig(self, nearbySelectionConfig: org.optaplanner.core.config.heuristic.selector.common.nearby.NearbySelectionConfig) -> 'ValueSelectorConfig': ...
    def withProbabilityWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionProbabilityWeightFactory]) -> 'ValueSelectorConfig': ...
    def withSelectedCountLimit(self, long: int) -> 'ValueSelectorConfig': ...
    def withSelectionOrder(self, selectionOrder: org.optaplanner.core.config.heuristic.selector.common.SelectionOrder) -> 'ValueSelectorConfig': ...
    def withSorterClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorter]) -> 'ValueSelectorConfig': ...
    def withSorterComparatorClass(self, class_: typing.Type[java.util.Comparator]) -> 'ValueSelectorConfig': ...
    def withSorterManner(self, valueSorterManner: 'ValueSorterManner') -> 'ValueSelectorConfig': ...
    def withSorterOrder(self, selectionSorterOrder: org.optaplanner.core.config.heuristic.selector.common.decorator.SelectionSorterOrder) -> 'ValueSelectorConfig': ...
    def withSorterWeightFactoryClass(self, class_: typing.Type[org.optaplanner.core.impl.heuristic.selector.common.decorator.SelectionSorterWeightFactory]) -> 'ValueSelectorConfig': ...
    def withVariableName(self, string: str) -> 'ValueSelectorConfig': ...

class ValueSorterManner(java.lang.Enum['ValueSorterManner']):
    NONE: typing.ClassVar['ValueSorterManner'] = ...
    INCREASING_STRENGTH: typing.ClassVar['ValueSorterManner'] = ...
    INCREASING_STRENGTH_IF_AVAILABLE: typing.ClassVar['ValueSorterManner'] = ...
    DECREASING_STRENGTH: typing.ClassVar['ValueSorterManner'] = ...
    DECREASING_STRENGTH_IF_AVAILABLE: typing.ClassVar['ValueSorterManner'] = ...
    _valueOf_0__T = typing.TypeVar('_valueOf_0__T', bound=java.lang.Enum)  # <T>
    @typing.overload
    @staticmethod
    def valueOf(class_: typing.Type[_valueOf_0__T], string: str) -> _valueOf_0__T: ...
    @typing.overload
    @staticmethod
    def valueOf(string: str) -> 'ValueSorterManner': ...
    @staticmethod
    def values() -> typing.MutableSequence['ValueSorterManner']: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.config.heuristic.selector.value")``.

    ValueSelectorConfig: typing.Type[ValueSelectorConfig]
    ValueSorterManner: typing.Type[ValueSorterManner]
    chained: org.optaplanner.core.config.heuristic.selector.value.chained.__module_protocol__
