
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import java.util
import java.util.function
import org.optaplanner.core.config
import org.optaplanner.core.config.localsearch.decider.acceptor.stepcountinghillclimbing
import typing



class AcceptorType(java.lang.Enum['AcceptorType']):
    HILL_CLIMBING: typing.ClassVar['AcceptorType'] = ...
    ENTITY_TABU: typing.ClassVar['AcceptorType'] = ...
    VALUE_TABU: typing.ClassVar['AcceptorType'] = ...
    MOVE_TABU: typing.ClassVar['AcceptorType'] = ...
    UNDO_MOVE_TABU: typing.ClassVar['AcceptorType'] = ...
    SIMULATED_ANNEALING: typing.ClassVar['AcceptorType'] = ...
    LATE_ACCEPTANCE: typing.ClassVar['AcceptorType'] = ...
    GREAT_DELUGE: typing.ClassVar['AcceptorType'] = ...
    STEP_COUNTING_HILL_CLIMBING: typing.ClassVar['AcceptorType'] = ...
    _valueOf_0__T = typing.TypeVar('_valueOf_0__T', bound=java.lang.Enum)  # <T>
    @typing.overload
    @staticmethod
    def valueOf(class_: typing.Type[_valueOf_0__T], string: str) -> _valueOf_0__T: ...
    @typing.overload
    @staticmethod
    def valueOf(string: str) -> 'AcceptorType': ...
    @staticmethod
    def values() -> typing.MutableSequence['AcceptorType']: ...

class LocalSearchAcceptorConfig(org.optaplanner.core.config.AbstractConfig['LocalSearchAcceptorConfig']):
    def __init__(self): ...
    def copyConfig(self) -> 'LocalSearchAcceptorConfig': ...
    def getAcceptorTypeList(self) -> java.util.List[AcceptorType]: ...
    def getEntityTabuRatio(self) -> float: ...
    def getEntityTabuSize(self) -> int: ...
    def getFadingEntityTabuRatio(self) -> float: ...
    def getFadingEntityTabuSize(self) -> int: ...
    def getFadingMoveTabuSize(self) -> int: ...
    def getFadingUndoMoveTabuSize(self) -> int: ...
    def getFadingValueTabuRatio(self) -> float: ...
    def getFadingValueTabuSize(self) -> int: ...
    def getGreatDelugeWaterLevelIncrementRatio(self) -> float: ...
    def getGreatDelugeWaterLevelIncrementScore(self) -> str: ...
    def getLateAcceptanceSize(self) -> int: ...
    def getMoveTabuSize(self) -> int: ...
    def getSimulatedAnnealingStartingTemperature(self) -> str: ...
    def getStepCountingHillClimbingSize(self) -> int: ...
    def getStepCountingHillClimbingType(self) -> org.optaplanner.core.config.localsearch.decider.acceptor.stepcountinghillclimbing.StepCountingHillClimbingType: ...
    def getUndoMoveTabuSize(self) -> int: ...
    def getValueTabuRatio(self) -> float: ...
    def getValueTabuSize(self) -> int: ...
    def inherit(self, localSearchAcceptorConfig: 'LocalSearchAcceptorConfig') -> 'LocalSearchAcceptorConfig': ...
    def setAcceptorTypeList(self, list: java.util.List[AcceptorType]) -> None: ...
    def setEntityTabuRatio(self, double: float) -> None: ...
    def setEntityTabuSize(self, integer: int) -> None: ...
    def setFadingEntityTabuRatio(self, double: float) -> None: ...
    def setFadingEntityTabuSize(self, integer: int) -> None: ...
    def setFadingMoveTabuSize(self, integer: int) -> None: ...
    def setFadingUndoMoveTabuSize(self, integer: int) -> None: ...
    def setFadingValueTabuRatio(self, double: float) -> None: ...
    def setFadingValueTabuSize(self, integer: int) -> None: ...
    def setGreatDelugeWaterLevelIncrementRatio(self, double: float) -> None: ...
    def setGreatDelugeWaterLevelIncrementScore(self, string: str) -> None: ...
    def setLateAcceptanceSize(self, integer: int) -> None: ...
    def setMoveTabuSize(self, integer: int) -> None: ...
    def setSimulatedAnnealingStartingTemperature(self, string: str) -> None: ...
    def setStepCountingHillClimbingSize(self, integer: int) -> None: ...
    def setStepCountingHillClimbingType(self, stepCountingHillClimbingType: org.optaplanner.core.config.localsearch.decider.acceptor.stepcountinghillclimbing.StepCountingHillClimbingType) -> None: ...
    def setUndoMoveTabuSize(self, integer: int) -> None: ...
    def setValueTabuRatio(self, double: float) -> None: ...
    def setValueTabuSize(self, integer: int) -> None: ...
    def visitReferencedClasses(self, consumer: typing.Union[java.util.function.Consumer[typing.Type[typing.Any]], typing.Callable[[typing.Type[typing.Any]], None]]) -> None: ...
    def withAcceptorTypeList(self, list: java.util.List[AcceptorType]) -> 'LocalSearchAcceptorConfig': ...
    def withEntityTabuRatio(self, double: float) -> 'LocalSearchAcceptorConfig': ...
    def withEntityTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withFadingEntityTabuRatio(self, double: float) -> 'LocalSearchAcceptorConfig': ...
    def withFadingEntityTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withFadingMoveTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withFadingUndoMoveTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withFadingValueTabuRatio(self, double: float) -> 'LocalSearchAcceptorConfig': ...
    def withFadingValueTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withLateAcceptanceSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withMoveTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withSimulatedAnnealingStartingTemperature(self, string: str) -> 'LocalSearchAcceptorConfig': ...
    def withStepCountingHillClimbingSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withStepCountingHillClimbingType(self, stepCountingHillClimbingType: org.optaplanner.core.config.localsearch.decider.acceptor.stepcountinghillclimbing.StepCountingHillClimbingType) -> 'LocalSearchAcceptorConfig': ...
    def withUndoMoveTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...
    def withValueTabuRatio(self, double: float) -> 'LocalSearchAcceptorConfig': ...
    def withValueTabuSize(self, integer: int) -> 'LocalSearchAcceptorConfig': ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.config.localsearch.decider.acceptor")``.

    AcceptorType: typing.Type[AcceptorType]
    LocalSearchAcceptorConfig: typing.Type[LocalSearchAcceptorConfig]
    stepcountinghillclimbing: org.optaplanner.core.config.localsearch.decider.acceptor.stepcountinghillclimbing.__module_protocol__
