
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import _jpype
import io.micrometer.core.instrument
import java.lang
import java.util
import java.util.concurrent.atomic
import java.util.function
import org.optaplanner.core.api.score
import org.optaplanner.core.api.solver
import org.optaplanner.core.config
import org.optaplanner.core.impl.score.definition
import typing



class MonitoringConfig(org.optaplanner.core.config.AbstractConfig['MonitoringConfig']):
    def __init__(self): ...
    def copyConfig(self) -> 'MonitoringConfig': ...
    def getSolverMetricList(self) -> java.util.List['SolverMetric']: ...
    def inherit(self, monitoringConfig: 'MonitoringConfig') -> 'MonitoringConfig': ...
    def setSolverMetricList(self, list: java.util.List['SolverMetric']) -> None: ...
    def visitReferencedClasses(self, consumer: typing.Union[java.util.function.Consumer[typing.Type[typing.Any]], typing.Callable[[typing.Type[typing.Any]], None]]) -> None: ...
    def withSolverMetricList(self, list: java.util.List['SolverMetric']) -> 'MonitoringConfig': ...

class SolverMetric(java.lang.Enum['SolverMetric']):
    SOLVE_DURATION: typing.ClassVar['SolverMetric'] = ...
    ERROR_COUNT: typing.ClassVar['SolverMetric'] = ...
    BEST_SCORE: typing.ClassVar['SolverMetric'] = ...
    STEP_SCORE: typing.ClassVar['SolverMetric'] = ...
    SCORE_CALCULATION_COUNT: typing.ClassVar['SolverMetric'] = ...
    BEST_SOLUTION_MUTATION: typing.ClassVar['SolverMetric'] = ...
    MOVE_COUNT_PER_STEP: typing.ClassVar['SolverMetric'] = ...
    MEMORY_USE: typing.ClassVar['SolverMetric'] = ...
    CONSTRAINT_MATCH_TOTAL_BEST_SCORE: typing.ClassVar['SolverMetric'] = ...
    CONSTRAINT_MATCH_TOTAL_STEP_SCORE: typing.ClassVar['SolverMetric'] = ...
    PICKED_MOVE_TYPE_BEST_SCORE_DIFF: typing.ClassVar['SolverMetric'] = ...
    PICKED_MOVE_TYPE_STEP_SCORE_DIFF: typing.ClassVar['SolverMetric'] = ...
    def getMeterId(self) -> str: ...
    def isMetricBestSolutionBased(self) -> bool: ...
    def register(self, solver: org.optaplanner.core.api.solver.Solver[typing.Any]) -> None: ...
    @staticmethod
    def registerScoreMetrics(solverMetric: 'SolverMetric', tags: io.micrometer.core.instrument.Tags, scoreDefinition: org.optaplanner.core.impl.score.definition.ScoreDefinition[typing.Any], map: typing.Union[java.util.Map[io.micrometer.core.instrument.Tags, java.util.List[java.util.concurrent.atomic.AtomicReference[typing.Union[_jpype._JNumberLong, _jpype._JNumberFloat, typing.SupportsIndex, typing.SupportsFloat]]]], typing.Mapping[io.micrometer.core.instrument.Tags, java.util.List[java.util.concurrent.atomic.AtomicReference[typing.Union[_jpype._JNumberLong, _jpype._JNumberFloat, typing.SupportsIndex, typing.SupportsFloat]]]]], score2: org.optaplanner.core.api.score.Score[typing.Any]) -> None: ...
    def unregister(self, solver: org.optaplanner.core.api.solver.Solver[typing.Any]) -> None: ...
    _valueOf_0__T = typing.TypeVar('_valueOf_0__T', bound=java.lang.Enum)  # <T>
    @typing.overload
    @staticmethod
    def valueOf(class_: typing.Type[_valueOf_0__T], string: str) -> _valueOf_0__T: ...
    @typing.overload
    @staticmethod
    def valueOf(string: str) -> 'SolverMetric': ...
    @staticmethod
    def values() -> typing.MutableSequence['SolverMetric']: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.config.solver.monitoring")``.

    MonitoringConfig: typing.Type[MonitoringConfig]
    SolverMetric: typing.Type[SolverMetric]
